/**
 * Author: Michael Daniels
 * Key:	Zaltron
 **/

Graph
	var
		size
		adjLists[0][0]

	/**
	 * Function:	New()
	 * Desc:		Constructor.
	 * Return Type: Graph
	 **/
	New()
		..()

	/**
	 * Function:	addVertex(Vertex v)
	 * Desc:		Adds a new Vertex to the graph.
	 * Return Type: void
	 **/
	proc/addVertex(Vertex/v)
		adjLists[v.getLabel()] = new/list()

	/**
	 * Function:	addEdge(Vertex a, Vertex b, int w)
	 * Desc:		Adds a directed Edge between two Vertices.
	 * Return Type: void
	 **/
	proc/addEdge(Vertex/a, Vertex/b, w)
		var/list/L = adjLists[a.getLabel()]
		L.Add(new/Edge(a,b,w))
		size++

	/**
	 * Function:	getAdjList(Vertex a)
	 * Desc:		Returns a list of Edges connected to Vertex a.
	 * Return Type: list
	 **/
	proc/getAdjList(Vertex/a)
		return adjLists[a.getLabel()]

	/**
	 * Function:	clearAll()
	 * Desc:		[...]
	 * Return Type: void
	 **/
	proc/clearAll()
