/**
 * Author: Michael Daniels
 * Key:	Zaltron
 **/

#define vWHITE 0
#define vGREY 1
#define vBLACK 2

Vertex
	var
		label = null
		datum/data = null
		Vertex/prev = null
		color = vWHITE

	/**
	 * Function:    New(String label, Object data, Vertex p)
	 * Desc:        Vertex Constructor.
	 * Return Type: Vertex
	 **/
	New(_label, _data, Vertex/_prev)
		..()
		label = _label
		data = _data
		setPrev(_prev)

	/**
	 * Function:    getLabel()
	 * Desc:        Returns a Vertex's label.
	 * Return Type: String
	 **/
	proc/getLabel()
		return label

	/**
	 * Function:    getData()
	 * Desc:        Returns data stored in a Vertex.
	 * Return Type: Object
	 **/
	proc/getData()
		return data

	/**
	 * Function:    setPrev(Vertex prev)
	 * Desc:        Sets a Vertex's prev to another Vertex.
	 * Return Type: void
	 **/
	proc/setPrev(Vertex/p)
		prev = p

	/**
	 * Function:    getPrev()
	 * Desc:        Returns a Vertex's prev.
	 * Return Type: Vertex
	 **/
	proc/getPrev()
		return prev

	/**
	 * Function:    setColor(var c)
	 * Desc:        Changes a Vertex's color.
	 * Return Type: void
	 **/
	proc/setColor(c)
		color = c

	/**
	 * Function:    getColor()
	 * Desc:        Returns a Vertex's color.
	 * Return Type: int
	 **/
	proc/getColor()
		return color

