/**
 * Author: Michael Daniels
 * Key:	Zaltron
 **/


#define DEBUG

//Constructs a new Graph and a list to store Vertices
var
	Graph/graph = new/Graph()
	vertexMap = list()

//Sets up the graph by adding Vertices into it then adding Edges to those Vertices.
world/New()
	..()
	for(var/i = 0, i <= 6, i++)
		var/Vertex/v = new/Vertex("v[i]", null, 0)
		vertexMap[v.getLabel()] = v
		graph.addVertex(v)
	graph.addEdge(vertexMap["v0"], vertexMap["v1"], 2)
	graph.addEdge(vertexMap["v0"], vertexMap["v3"], 1)
	graph.addEdge(vertexMap["v1"], vertexMap["v3"], 3)
	graph.addEdge(vertexMap["v1"], vertexMap["v4"], 10)
	graph.addEdge(vertexMap["v2"], vertexMap["v0"], 4)
	graph.addEdge(vertexMap["v2"], vertexMap["v5"], 5)
	graph.addEdge(vertexMap["v3"], vertexMap["v2"], 2)
	graph.addEdge(vertexMap["v3"], vertexMap["v4"], 2)
	graph.addEdge(vertexMap["v3"], vertexMap["v5"], 8)
	graph.addEdge(vertexMap["v3"], vertexMap["v6"], 4)
	graph.addEdge(vertexMap["v4"], vertexMap["v6"], 6)
	graph.addEdge(vertexMap["v6"], vertexMap["v5"], 1)

//Prints out the Graph's size and checks to see if there is a path from Vertex v0 to Vertex v1.
client/New()
	..()
	world<<"Graph size: [graph.size]"
	if(hasPath(graph, vertexMap["v0"], vertexMap["v1"]))
		world<<"True!"

client/Del()
	del(mob)
	..()